image: "python:3.8"

before_script:
  - python --version
  - pip install -r requirements-dev.txt

stages:
  - Static Analysis
  - Build
  - Test

syntax:
  stage: Static Analysis
  script:
    - python -m compileall export_plan

pylint:
  stage: Static Analysis
  script:
    - pylint export_plan

mypy:
  stage: Static Analysis
  script:
    - mypy -p export_plan
  allow_failure: true

package:
  stage: Build
  script:
    - pip install twine
    - python setup.py sdist bdist_wheel
    - TWINE_PASSWORD=${CI_JOB_TOKEN} TWINE_USERNAME=gitlab-ci-token python -m twine upload --repository-url https://gitlab.com/api/v4/projects/${CI_PROJECT_ID}/packages/pypi dist/*
